
import os
from spruce import Utils
from spruce.Information import MP3Meta

class StaticSong:
	
	_file = ""
	_artist = ""
	_album = ""
	_title = ""
	_genre = ""
	_bitrate = ""
	_time = ""
	_filesize = ""
	
	_id = ""
	parsedID3 = 0
	
	
	def __init__(self, file, artist, album, title, genre):
		if not os.path.exists(file):
			raise Exception("File not found: %s" % file) 
		
		self._file = file
		self._artist = artist
		self._album = album
		self._title = title
		self._genre = genre
		self._readMetaInfo()
		self._filesize = os.path.getsize(self.getFile())
		


	def isOnIPod(self):
		if(self.getFile().find("/mnt/ipod/") == 0):
			return 1
		else:
			return 0
		
	def _readMetaInfo(self):
		info = MP3Meta.mp3info(self.getFile())
		self._bitrate = info["BITRATE"]
		self._time = (info["SS"] + (info["MM"] * 60)) * 1000
		
		
	#
	# read/write property accessors
	#

	def setId(self, id):
		self._id = id

	def getId(self):
		return self._id

	def getFile(self):
		return self._file

	def setFile(self, file):
		self._file = file
		


	#
	# read property accessors
	#

	def getArtist(self):
 		return self._artist
		
	def getAlbum(self):
 		return self._album

	def getTitle(self):
 		return self._title
				
	def getGenre(self):
		return self._genre

	def getTrackNumber(self):
		return 1

	def getAmountOfTracks(self):
		return 10

	def getYear(self):
		return 2002

	def getComment(self):
		return self._title

	def getBitrate(self):
		return self._bitrate
		
	def getTime(self):
		return self._time
		

	def getFilesize(self):
		return self._filesize
		
		
	def getIpodCompatibleFile(self):
		path = self._file.replace("/mnt/ipod", "")
		path = path.replace("/", ":")
		
		return path

	def getCDNumber(self):
		return 0
	

	def getAmountOfCDs(self):
		return 0
		
		
		
	def equals(self, other):
		if self.getFilesize() != other.getFilesize():
			return 0
			
		if self.getArtist() != other.getArtist():
			return 0
		
		if self.getAlbum() != other.getAlbum():
			return 0
		
		
		if self.getTitle() != other.getTitle():
			return 0
		
		if self.getFile().split("/")[-1] != other.getFile().split("/")[-1]:
			return 0
		
		return 1
		

	def writeID3(self):
		print "trying to write a id3 tag to a static song: %s"  % self.getIpodCompatibleFile()
