#
# this script was originally written by Ted Whalen <tew@fortpedro.com>
# and modified a bit by florian weber <florian@structbench.com>
# for the use within spruce and whale.
#
#

from __future__ import generators
import struct
import sys
from spruce.Songs import Song
from spruce.Songs import StaticSong
from spruce import Utils
import pygtk
pygtk.require("2.0")
import gtk

createPlaylistMethod = ""
addSongMethod = ""
finishedMethod = ""


def importDatabase(file):

	contents = open(file,'r').read()
	file_pos = 0
	file_len = len(contents)

	code_names = {1:'Title',
	  2:'Filename',
	  3:'Album',
	  4:'Artist',
	  5:'Genre',
	  6:'Filetype',
	  7:'Unknown',
	  8:'Comment',
	  100:'Unknown'}

	item_id = 0
	item = {}
	items = {}
	prop_count = 0

	currentContext = ""
	currentSongId = ""
	songList = dict()
	playlistCount = 0
	


	while file_pos < file_len: # move through the file
		first_16_bytes = contents[file_pos:file_pos+16]
		second_16_bytes = contents[file_pos+16:file_pos+32]
		pad, code, jump, myLen, count = struct.unpack("<2s2sLLL", first_16_bytes)

		if prop_count == 0 and item:
			items[item_id] = item
			item = {}
			item_id = 0
		if code == "bd": # start code, beginning of database
			pass

		elif code == "it": # a song list item
			item_id,x,x,x = struct.unpack("<LLLL", second_16_bytes)
			currentSongId = item_id
			prop_count = count

		elif code == "sd": # a list starter
			# myLen indicates the size of the directory
			# count is a typecode:
			if count == 1:
				#print "%.8x List of Songs:" % file_pos
				currentContext = "songList"
			elif count == 2:
				#print "%.8x List of Playlists:" % file_pos
				currentContext = "playlists"
			else:
				pass #print "%.8x Unknown (%i)" % (file_pos, count)

		elif code == "lt": # a list starter
			# count is meaningless (usually 0)
			# myLen is the number of upcoming items
			#print "%.8x %i-item list:" % (file_pos, myLen)
			pass
			
		elif code == "ip": # a playlist item
			x,x,item_ref,x,x = struct.unpack("<LLLHH",second_16_bytes)
			try:
				item = items[item_ref]
				if playlistCount > 1:
					song = songList.get(item_ref)
					songFile = str(song[1]).replace(":", "/")
					addSongMethod(playlistCount - 2, StaticSong("/mnt/ipod" + songFile, \
								song[3], song[2], song[0], song[4]))
					
			except KeyError:
				print "%.8x: itemref (%i) XXX" % (file_pos+16, item_ref)

		elif code == "od": # a unicode string, usually.
			# count is the item type.
			x,strlen,x,x = struct.unpack("<LLLL",contents[file_pos+jump:file_pos+jump+16])
			if strlen != 0:
				fudge = 40 # jump is /always/ 24, so 24 + 16bytes = 40
				data =  unicode(contents[file_pos+fudge:file_pos+myLen],'utf-16-le',"x")
				if item_id:
					item[code_names[count]] = data

				if code_names[count] != "Unknown":
				   if currentContext == "playlists":
				   	  if playlistCount > 0:
						createPlaylistMethod(data, 0)						   
					  
					  playlistCount += 1
					  
				   else:
				      if count == 1:
						songList[currentSongId] = list()
						
				      songList[currentSongId].append(data)
				else: 
					pass
				prop_count = prop_count - 1
			jump = myLen # skip to end of this string.

		else: # something mysterious and new
			pass

		file_pos = file_pos + jump
		
		yield gtk.TRUE
		
	Utils.debug("iTunesDBImport", "Finished iTunesDB loading")
	finishedMethod()	
