#
# this script has been ported from c out of the gtkpod (gtkpod.sf.net)
# itunesdb.c file, which has been ported from perl out of
# the gnupod (gnupod-tools: http://www.blinkenlights.ch/cgi-bin/fm.pl?get=ipod)
# mktunes.pl script.
#
# thanks alot to to jorg schuler and jdahlin for the kind support.
#


import struct




getMasterPlaylistMethod = ""
getPlaylistsMethod = ""



MHOD_ID_TITLE = 1
MHOD_ID_PATH = 2
MHOD_ID_ALBUM = 3
MHOD_ID_ARTIST = 4
MHOD_ID_GENRE = 5
MHOD_ID_FDESC = 6
MHOD_ID_COMMENT = 8
MHOD_ID_COMPOSER = 12
MHOD_ID_PLAYLIST = 100

DEBUG = 0

def debug(message):
	if DEBUG == 1:
		print message


# return dummy mac time stamp -- maybe we can improve later 
# iPod doesn't seem to care...? 
def getMacTimestamp():
	return 0x8c3abf9b



def write_it(file):
  	mhbd_seek = 0 
 	makeMhbd(file)
	writeMhsdOne(file)
	writeMhsdTwo(file)	
   	fixMhbd(file, mhbd_seek, file.tell())


def itunesdb_write_to_file():
	file = open("/mnt/ipod/iPod_Control/iTunes/iTunesDB", "wb")
	write_it(file);
	file.close()





def writeMhsdOne(file):
	songCollection = getMasterPlaylistMethod().getSongs()
	song_num = len(songCollection)
	
	mhsd_seek = file.tell()
 	makeMhsd(file, 1)
 	mhlt_seek = file.tell()
 	mkMhlt(file, song_num)

	i=0
	
	for song in songCollection:
		mhit_seek = file.tell()
		# FIXME! Gotta pass the real song object here
		
		makeMhit(file, song)
		mhod_num = 0;
	
  		if(song.getTitle()):
 			makeMhod(file, MHOD_ID_TITLE, song.getTitle(), 1)
 			mhod_num += 1

		if(song.getIpodCompatibleFile()):
			makeMhod(file, MHOD_ID_PATH, song.getIpodCompatibleFile(), 1);
			mhod_num += 1

		if(song.getAlbum()):
			makeMhod(file, MHOD_ID_ALBUM, song.getAlbum(), 1);
	    	mhod_num += 1
			
		if(song.getArtist()):
			makeMhod(file, MHOD_ID_ARTIST, song.getArtist(), 1);
	    	mhod_num += 1

		if(song.getGenre()):
			makeMhod(file, MHOD_ID_GENRE, song.getGenre(), 1);
	    	mhod_num += 1
			

		if(song.getComment()):
			makeMhod(file, MHOD_ID_COMMENT, song.getComment(), 1);
	    	mhod_num += 1



 
		fixMhit(file, mhit_seek, file.tell(), mhod_num);
		
		i += 1
				
		
	fixMhsd(file, mhsd_seek, file.tell());



def writeMhsdTwo(file):
	mhsd_seek = file.tell()
	makeMhsd(file, 2)
	mhlp_seek = file.tell()
	
	playlists = list(getPlaylistsMethod())
	playlists.insert(0, getMasterPlaylistMethod())
	
	playlistsNum = len(playlists)
	debug("number of playlists: %s " % playlistsNum) 
 	
	makeMhlp(file, playlistsNum);
	
	
	for playlist in playlists:
		debug("Writing playlist: %s " % playlist.getName()) 
		writePlaylist(file, playlist)



 	fixMhlp(file, mhlp_seek, playlistsNum)
 	fixMhsd(file, mhsd_seek, file.tell())
 	



def makeTwoByteString(string):
	
	result = ""
	for char in string:
		result += char + '\0'
		
	return result



def fixupUTF16(string):


	if string:
		i = 0
		result = ""
 		while i < len(string):
 			result += struct.pack('>B',(ord(string[i]) << 8) & 0xff00) #| struct.pack('>B',(ord(string[i]) >> 8) & 0xff)
			i += 1
	return string



#
# All the put functions
#
#
#


def putDataCur(file, data, n):
	file.write(data)
	file.write('\0'*(n - len(data)))
	
	

def put4intCur(file, n):
	 return file.write(struct.pack('<L', n))
	


def put4intSeek(file, n, seek):
	file.seek(seek, 0)
	file.write(struct.pack('<L', n))
	file.seek(0, 2)

	

def putN0Cur(file, n):
	i=0
	while(i<n):
		put4intCur(file, 0)
		i += 1



def writePlaylist(file, playlist):
	mhyp_seek = file.tell();

	debug("writing playlist: %s " % playlist.getName()) 
	songs = playlist.getSongs()
	songNum = len(songs)
	
	if playlist.__class__.__name__ == "MasterPlaylist":
		playlistKind = 1
	else:
		playlistKind = 0
		
	makeMhyp(file, playlist.getName(), playlistKind, songNum)
     

 	for song in songs:
		debug("   > writing song: %s " % song.getTitle()) 
 		makeMhip(file, song.getId());
 		makeMhod(file, MHOD_ID_PLAYLIST, "", song.getId())
 

	fixMhyp(file, mhyp_seek, file.tell())
	


#
# All the make functions
#
#
#

def makeMhod(file, type, string, fqid):
	if(fqid == 1):
		mod = 40;   #/* normal mhod */
  	else:        
		mod = 44;   #/* playlist entry */

	
  	length = len(string)


 	putDataCur(file, "mhod", 4)
  	put4intCur(file, 24)
	put4intCur(file, 2*length+mod)
  	put4intCur(file, type)
  	putN0Cur(file, 2)
  	put4intCur(file, fqid)
	put4intCur(file, 2*length)

	#data = struct.pack('<4sLLLLLL', "mhod", 24, 2*length+mod, type, 0, fqid, 2*length)
	#file.write(data)

	if(type < 100):
 		putN0Cur(file, 2)
 		putDataCur(file, makeTwoByteString(string), 2*length)
 
 	else:                             
 		putN0Cur(file, 3)
		
		

def makeMhbd(file):
	putDataCur(file, "mhbd", 4)
	put4intCur(file, 104)
	put4intCur(file, -1)
	put4intCur(file, 1)
	put4intCur(file, 1)
	put4intCur(file, 2)
	putN0Cur(file, 20)



def makeMhsd(file, type):
	putDataCur(file, "mhsd", 4)
	put4intCur(file, 96)
	put4intCur(file, -1)
	put4intCur(file, type)
	putN0Cur(file, 20)
	


def mkMhlt(file, songNum):
	putDataCur(file, "mhlt", 4)
	put4intCur(file, 92)
	put4intCur(file, songNum)
	putN0Cur(file, 20)


def makeMhit(file, song):
	putDataCur(file, "mhit", 4)
	put4intCur(file, 156)  #header size */
	put4intCur(file, -1)   #size of whole mhit -- fill in later */
	put4intCur(file, -1)   #nr of mhods in this mhit -- later   */
	put4intCur(file, song.getId()) #song index number          */
	put4intCur(file, 1)
	put4intCur(file, 0)
	put4intCur(file, 256)           #type                       */
	put4intCur(file, getMacTimestamp())     #timestamp                  */
	put4intCur(file, song.getFilesize())    #filesize                   */
	put4intCur(file, song.getTime()) #length of song in ms       */
	put4intCur(file, song.getTrackNumber())#track number               */
	put4intCur(file, song.getAmountOfTracks())  #number of tracks           */
	put4intCur(file, song.getYear())    #the year                   */
	put4intCur(file, song.getBitrate()) #bitrate                    */
	put4intCur(file, 0xac440000)    #?                          */
	putN0Cur(file, 7)               #dummy space                */
	put4intCur(file, song.getCDNumber())   #CD number                  */
	put4intCur(file, song.getAmountOfCDs())     #number of CDs              */
	put4intCur(file, 0)             #hardcoded space            */
	put4intCur(file, getMacTimestamp())     #timestamp                  */
	putN0Cur(file, 12)              #dummy space                */

	
def makeWeired(file):
	putDataCur(file, "mhod", 4)      # header                   */
	put4intCur(file, 0x18)           # size of header  ?        */
	put4intCur(file, 0x0288)         # size of header + body    */
	put4intCur(file, 0x64)           # type of the entry        */
	putN0Cur(file, 6)
	put4intCur(file, 0x010084)       # ? */
	put4intCur(file, 0x05)           # ? */
	put4intCur(file, 0x09)           # ? */
	put4intCur(file, 0x03)           # ? */
	put4intCur(file, 0x120001)       # ? */
	putN0Cur(file, 3)
	put4intCur(file, 0xc80002)       # ? */
	putN0Cur(file, 3)
	put4intCur(file, 0x3c000d)       # ? */
	putN0Cur(file, 3)
	put4intCur(file, 0x7d0004)       # ? */
	putN0Cur(file, 3)
	put4intCur(file, 0x7d0003)       # ? */
	putN0Cur(file, 3)
	put4intCur(file, 0x640008)       # ? */
	putN0Cur(file, 3)
	put4intCur(file, 0x640017)       # ? */
	put4intCur(file, 0x01)           # bool?(visible? / colums?) */
	putN0Cur(file, 2)
	put4intCur(file, 0x500014)       # ? */
	put4intCur(file, 0x01)           # bool?(visible?) */
	putN0Cur(file, 2)
	put4intCur(file, 0x7d0015)       # ? */
	put4intCur(file, 0x01)           # bool?(visible?) */
	putN0Cur(file, 114)



def makeMhip(file, id):
	putDataCur(file, "mhip", 4)
	put4intCur(file, 76)
	put4intCur(file, 76)
	put4intCur(file, 1)
	put4intCur(file, 0)
	put4intCur(file, id)   # song id in playlist */
	put4intCur(file, id)  # ditto.. don't know the difference, but this
	putN0Cur(file, 12) 




def makeMhyp(file, listname, type, song_num):
	putDataCur(file, "mhyp", 4)     	 # header                   */
	put4intCur(file, 108)            # length		   */
	put4intCur(file, -1)             # size . later            */
	put4intCur(file, 2)              # ?                        */
  	put4intCur(file, song_num)       # number of songs in plist */
  	put4intCur(file, type)           # 1 = main, 0 = visible    */
  	put4intCur(file, 0)              # ?                        */
  	put4intCur(file, 0)              # ?                        */
  	put4intCur(file, 0)              # ?                        */
  	putN0Cur(file, 18)               # dummy space              */
  	makeWeired(file)
	debug("the list %s " % listname) 
   	makeMhod(file, MHOD_ID_TITLE, listname, 1)



def makeMhlp(file, lists):
	putDataCur(file, "mhlp", 4)      # header                   */
	put4intCur(file, 92)             # size of header           */
	put4intCur(file, lists)          # playlists on iPod(including main!) */
	putN0Cur(file, 20)               # dummy space              */




#
# All the fix functions
#
#
#


def fixMhbd(file, mhbdSeek, cur):
	put4intSeek(file, cur-mhbdSeek, mhbdSeek+8)
	

def fixMhsd(file, mhsdSeek, cur):
	put4intSeek(file, cur-mhsdSeek, mhsdSeek+8)
	
	
def fixMhlp(file, mhlpSeek, playlistNum):
	put4intSeek(file, playlistNum, mhlpSeek+8) # nr of playlists    */



def fixMhyp(file, mhypSeek, cur):
	put4intSeek(file, cur-mhypSeek, mhypSeek+8)



def fixMhit(file, mhitSeek, cur, mhodNum):
	put4intSeek(file, cur-mhitSeek, mhitSeek+8) # size of whole mhit */
	put4intSeek(file, mhodNum, mhitSeek+12)     # nr of mhods        */	
	
	



def write():
	itunesdb_write_to_file()
	debug("wrote iTunesDB")
