

import gobject
import gtk
from gtk import gdk
from gtk import glade

from spruce.iPod import iPod


class Playlist:

	_ipod = ""
	_sprucePlaylistObject = ""

	COLUMN_ARTIST = 1
	COLUMN_ALBUM = 2
	COLUMN_SONG = 3
	COLUMN_FILE = 4
	COLUMN_OBJECT = 5

	songsNum = 0
	name = ""
	
	
	def __init__(self, name):
		self._ipod = iPod.getInstance()
		self._sprucePlaylistObject = self._ipod.createPlaylist(name)
		self._setupModel()
		self.name = name
		
	def _setupModel(self):
		self.model = gtk.ListStore(gobject.TYPE_UINT, 
								   gobject.TYPE_STRING, 
								   gobject.TYPE_STRING, 
								   gobject.TYPE_STRING,
								   gobject.TYPE_STRING, 
								   gobject.TYPE_PYOBJECT 
								  )		



	def addSong(self, song):

		self._sprucePlaylistObject.addSong(song)
	
		artist = song.getArtist()
		album = song.getAlbum()
		title = song.getTitle()
		
		# what a hack
		if artist.__class__.__name__ != "unicode":
			artist = unicode(song.getArtist(), 'iso-8859-1').encode('utf-8')
		
		if album.__class__.__name__ != "unicode":
			album = unicode(song.getAlbum(), 'iso-8859-1').encode('utf-8')		

		if title.__class__.__name__ != "unicode":
			title = unicode(song.getTitle(), 'iso-8859-1').encode('utf-8')	

		
		iter = self.model.append()
		self.model.set(iter, 
				self.COLUMN_ARTIST, artist, 
				self.COLUMN_ALBUM, album, 
				self.COLUMN_SONG, title,
				self.COLUMN_FILE, song.getFile(),
				self.COLUMN_OBJECT, song
			)

    
	def removeSong(self, iter):
		song = self.model.get_value(iter, self.COLUMN_OBJECT)
		self._sprucePlaylistObject.removeSong(song)
		self.model.remove(iter)

	def getName(self):
		return self.name

	def getSongsAmount(self):
		return self.model.iter_n_children(None)

	def getSongs(self):
		songList = []
		
		iter = self.model.get_iter_first()
		
		while iter:
			song = self.model.get_value(iter, self.COLUMN_OBJECT)
			songList.append(song)
		
			iter = self.model.iter_next(iter)


		return songList
						



