

import os
import sys
import pygtk
pygtk.require("2.0")
import gnome
import gconf


class Preferences:

	
    # Create a class variable that will hold a reference
    # to the single instance of TestSingleton.
	
	instance = None

    # Define a helper class that will override the __call___
    # method in order to provide a factory method for Preferences.

	client = gconf.client_get_default()
	
	
	class SingletonHelper:
		
		def __call__( self, *args, **kw ) :
		
            # If an instance of Preferences does not exist,
            # create one and assign it to Preferences.instance.
			
			if Preferences.instance is None:
				object = Preferences()
				Preferences.instance = object

            # Return Preferences.instance, which should contain
            # a reference to the only instance of Preferences
            # in the system.
					
			return Preferences.instance
				
    # Create a class level method that must be called to
    # get the single instance of Preferences.	
	
	getInstance = SingletonHelper()
	

	def getiPodPath(self):
		return "/mnt/ipod/"
		#return self.client.get_string("/apps/whale/ipod_mountpoint")


	def getDataDirectory(self):
		prefix, t = os.path.split(os.path.split(os.path.abspath(sys.argv[0]))[0])
		if t == 'bin':
			fp = os.path.join(prefix, 'share', 'whale')
			if os.path.isdir(fp):
				return fp
		
		fp = os.path.abspath("ui")
		if os.path.isdir(fp):
			return fp
			
		raise "FileNotFoundError", "couldn't find Whale data directory"	
		
	def setup(self):
		self.client.add_dir("/apps/whale", gconf.CLIENT_PRELOAD_RECURSIVE)
		self.client.set_string ("/apps/whale/ipod_mountpoint", "/mnt/ipod")
