

from FilesystemSongReader import FilesystemSongReader
from GladeAccessor import GladeAccessor
import gobject
import gtk
import urlparse
import urllib
from gtk import gdk
from gtk import glade
import os



COLUMN_NUM = 0
COLUMN_ARTIST = 1
COLUMN_ALBUM = 2
COLUMN_SONG = 3




PLAYING_ICON = "UI/pixmaps/playing-icon.png"




class SongViewer:

	_toDeleteRows = list()
	_DEBUG = 1
	_TARGET = [('text/uri-list', 0, 0)]
                
	def __init__(self):
     
 		gladeAccessor = GladeAccessor.getInstance()
		self.view = gladeAccessor.getWidget("songsView")
              
			  	
		self.view.set_rules_hint (gtk.TRUE)
		self.view.set_reorderable(gtk.TRUE)
  	
		self._setupColumns (self.view)            
		self.view.connect('drag_data_received', self._OnDragDragDataReceived)
		self.view.connect("key_press_event", self._on_key_press)       
		a = self.view.get_selection()
		a.set_mode(gtk.SELECTION_MULTIPLE)   
		self.enableDragging()
		self.disableDragging()
		   
		   
	def _addColumn(self, column):
		column.set_resizable(gtk.TRUE)
		self.view.append_column (column)


	def enableDragging(self):
		if self._DEBUG:
			print "[SongViewer] Enabling dragging"
		self.view.drag_dest_set(gtk.DEST_DEFAULT_ALL, self._TARGET, gtk.gdk.ACTION_COPY)


	def disableDragging(self):
		if self._DEBUG:
			print "[SongViewer] Disabling dragging"
		self.view.drag_dest_unset()


	def _OnDragDragDataReceived(self, w, context, x, y, data, info, time):
      
		a = FilesystemSongReader()
		a.setSongdataHandler(self.playlistManager.addSongToCurrentPlaylist)
        
		if data and data.format == 8:
			for uri in data.data.split('\r\n')[:-1]:
			
				path = urlparse.urlparse(urllib.unquote(uri))[2]
				
				if os.path.isfile(path):
					a.readFile(path)
				else:
					a.readDirectory(path)

		context.finish(gtk.TRUE, gtk.FALSE, time)



	def _setupColumns(self, treeview):
		renderer = gtk.CellRendererText ()
		column = gtk.TreeViewColumn (" Artist", renderer, text=COLUMN_ARTIST)
		column.set_sort_column_id(COLUMN_ARTIST)
		self._addColumn(column)

		renderer = gtk.CellRendererText ()
		column = gtk.TreeViewColumn (" Album", renderer, text=COLUMN_ALBUM)
		column.set_sort_column_id(COLUMN_ALBUM)
		self._addColumn(column)

		renderer = gtk.CellRendererText ()
		column = gtk.TreeViewColumn (" Song", renderer, text=COLUMN_SONG)
		column.set_sort_column_id(COLUMN_SONG)
		self._addColumn(column)




	def setModel(self, model):
		self.view.set_model(model)
		self.view.columns_autosize()


	def setPlaylistManager(self, obj):
		self.playlistManager = obj


	def _remindToDeleteRow(self, model, path, iter):
		self._toDeleteRows.append(iter)

   

	def deleteSelectedRows(self):
		playlist = self.playlistManager.getCurrentPlaylist()
		selection = self.view.get_selection() 
		selection.selected_foreach(self._remindToDeleteRow)
        
		for iter in self._toDeleteRows:
 			playlist.removeSong(iter)
        
		self._toDeleteRows = list()
   
   		self._ipod.update()
   
   
   
	def _on_key_press(self, path, event):
		if event.keyval == 65535 or event.keyval == 65288:
			self.deleteSelectedRows()
            
